<?php
namespace Modules\Cadastros\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Util\SupUtilities;

class CadastroCategoriaSupplyTekService {
    public function __construct(SupUtilities $supUtilities) {
        $this->supUtilities = $supUtilities;
    }
    
    /********************
     *      INSERTS     *
     * ******************/
     
    public function insertNewNotification($row) {
        try {
            $query = "INSERT INTO NOTIFICSUPPLY
                        (NRNOTIFICSUPPLY, CDFILIAL, CDOPERADOR, NMNOTIFICACAO, DSTEXTNOTIFIC, IDNOTIFICLIDO, NRORG, IDATIVO, DTINCLUSAO)
                    VALUES
                        (:NRNOTIFICSUPPLY, :CDFILIAL, :CDOPERADOR, :NMNOTIFICACAO, :DSTEXTNOTIFIC,:IDNOTIFICLIDO, :NRORG, :IDATIVO, :DTINCLUSAO)";
                        
            $params = [
                'NRNOTIFICSUPPLY'       => $row['NRNOTIFICSUPPLY'],
                'CDFILIAL'       => $row['CDFILIAL'],
                'CDOPERADOR'        => $row['CDOPERADOR'],
                'NMNOTIFICACAO'           => $row['NMNOTIFICACAO'],
                'IDNOTIFICLIDO'           => $row['IDNOTIFICLIDO'],
                'NRORG'           => $row['NRORG'],
                'IDATIVO'           => $row['IDATIVO'],
                'DTINCLUSAO'           => $row['DTINCLUSAO'],
                'DSTEXTNOTIFIC'             => $row['DSTEXTNOTIFIC']
            ];
            $this->supUtilities->crud($query, $params);
        }
        catch (Exception $e) {
             throw $e;
        }
    }
     
    public function insertNewCategory($row) {
        try {
            $query = "INSERT INTO CATEGORIASUPPLY
                        (CDCATEGORIA, NMCATEGORIA, CDDESPPREV, IDATIVO, NRORG)
                    VALUES
                        (:CDCATEGORIA, :NMCATEGORIA, :CDDESPPREV, :IDATIVO, :NRORG)";
                        
            $params = [
                'CDCATEGORIA'       => $row["CDCATEGORIA"],
                'NMCATEGORIA'       => $row['NMCATEGORIA'],
                'CDDESPPREV'        => $row['CDDESPPREV'],
                'IDATIVO'           => $row['IDATIVO'],
                'NRORG'             => $row['NRORG']
            ];
            $this->supUtilities->crud($query, $params);
        }
        catch (Exception $e) {
             throw $e;
        }
    }
    
    public function insertNewSubCategory($row) {
        try {
            $query = "INSERT INTO SUBCATEGSUPPLY
                        (CDSUBCATEGORIA, NMSUBCATEGORIA, CDCATEGORIA, IDATIVO, NRORG)
                    VALUES
                        (:CDSUBCATEGORIA, :NMSUBCATEGORIA, :CDCATEGORIA, :IDATIVO, :NRORG)";
                
                    $params = [
                        'CDSUBCATEGORIA'    => $row['CDSUBCATEGORIA'],
                        'NMSUBCATEGORIA'    => $row['NMSUBCATEGORIA'],
                        'CDCATEGORIA'       => $row['CDCATEGORIA'],
                        'IDATIVO'           => $row['IDATIVO'],
                        'NRORG'             => $row['NRORG']
                    ];
                    $this->supUtilities->crud($query, $params);
        }
        catch (Exception $e) {
             throw $e;
        }
    }
    
    public function insertNewProduct($row) {
        try {
            $sql = "INSERT INTO PRODSUPPLY
                    (
                        CDCATEGORIA, 
                        CDSUBCATEGORIA, 
                        CDFORNECED, 
                        NRCOLEPRECO, 
                        CDPRODUTO, 
                        IDATIVO, 
                        NRORG,
                        CDFILCOT,
                        CDREGIAO,
                        CDMARCA,
                        VRPRECUNIITM
                    )
                    VALUES
                    (
                        :P_CDCATEGORIA,
                        :P_CDSUBCATEGORIA,
                        :P_CDFORNECED,
                        :P_NRCOLEPRECO,
                        :P_CDPRODUTO,
                        :P_IDATIVO,
                        :P_NRORG,
                        :P_CDFILCOT,
                        :P_CDREGIAO,
                        :P_CDMARCA,
                        :P_VRPRECUNIITM
                    )";
        
            $params = [
                'P_CDCATEGORIA'    => $row['CDCATEGORIA'],
                'P_CDSUBCATEGORIA' => $row['CDSUBCATEGORIA'],
                'P_CDFORNECED'     => $row['CDFORNECED'],    
                'P_NRCOLEPRECO'    => $row['NRCOLEPRECO'],
                'P_CDPRODUTO'      => $row['CDPRODUTO'],
                'P_IDATIVO'        => $row['IDATIVO'],
                'P_NRORG'          => $row['NRORG'],
                'P_CDFILCOT'       => $row['CDFILIAL'],
                'P_CDREGIAO'       => $row['CDREGIAO'],
                'P_CDMARCA'        => $row['CDMARCA'],
                'P_VRPRECUNIITM'   => $row['VRPRECUNIITM']
            ];
            
            $this->supUtilities->crud($sql, $params);
        }
        catch (Exception $e) {
             throw $e;
        }
    }
     
       
    /********************
     *      UPDATES     *
     * ******************/
    public function updateCategory($row) 
    {
        try {
            $query = "UPDATE CATEGORIASUPPLY SET NMCATEGORIA = :NMCATEGORIA, CDDESPPREV = :CDDESPPREV, IDATIVO = 'S'
                        WHERE CDCATEGORIA = :CDCATEGORIA
                      AND NRORG = :NRORG";
                $params = [
                    'NMCATEGORIA'  => $row['NMCATEGORIA'],
                    'CDDESPPREV'  => $row['CDDESPPREV'],
                    'CDCATEGORIA'  => $row['CDCATEGORIA'],
                    'NRORG'           => $row['NRORG']
                ];
                $this->supUtilities->crud($query, $params);    
        }
        catch (Exception $e) {
             throw $e;
        }
    }
 
    public function inactivateSubCategory($row) 
    {
        try {
            $query = "UPDATE SUBCATEGSUPPLY SET IDATIVO = :IDATIVO
                        WHERE CDSUBCATEGORIA = :CDSUBCATEGORIA
                      AND NRORG = :NRORG";
                $params = [
                    'IDATIVO'  => 'N',
                    'CDSUBCATEGORIA'  => $row['CDSUBCATEGORIA'],
                    'NRORG'           => $row['NRORG']
                ];
                $this->supUtilities->crud($query, $params);    
        }
        catch (Exception $e) {
             throw $e;
        }
    }
    
    public function updateSubCategory($row) 
    {
        try {
            $query = "UPDATE SUBCATEGSUPPLY SET NMSUBCATEGORIA = :NMSUBCATEGORIA
                        WHERE CDSUBCATEGORIA = :CDSUBCATEGORIA
                      AND NRORG = :NRORG";
                $params = [
                    'NMSUBCATEGORIA'  => $row['NMSUBCATEGORIA'],
                    'CDSUBCATEGORIA'  => $row['CDSUBCATEGORIA'],
                    'NRORG'           => $row['NRORG']
                ];
                $this->supUtilities->crud($query, $params);    
        }
        catch (Exception $e) {
             throw $e;
        }
    }
    
    public function updateProduct($row) 
    {
        try {
            $query = "UPDATE PRODSUPPLY 
                         SET IDATIVO = :P_IDATIVO
                      WHERE CDCATEGORIA   = :P_CDCATEGORIA
                        AND CDSUBCATEGORIA = :P_CDSUBCATEGORIA
                        AND CDFORNECED = :P_CDFORNECED
                        AND NRCOLEPRECO = :P_NRCOLEPRECO
                        AND CDPRODUTO = :P_CDPRODUTO
                        AND CDMARCA = :P_CDMARCA
                        AND CDREGIAO = :P_CDREGIAO
                        AND NRORG = :P_NRORG";
                
                    $params = [
                        'P_CDCATEGORIA'       => $row['CDCATEGORIA'],
                        'P_CDSUBCATEGORIA'    => $row['CDSUBCATEGORIA'],
                        'P_CDFORNECED'        => $row['CDFORNECED'],    
                        'P_NRCOLEPRECO'       => $row['NRCOLEPRECO'],
                        'P_CDPRODUTO'         => $row['CDPRODUTO'],
                        'P_CDMARCA'           => $row['CDMARCA'],
                        'P_CDREGIAO'          => $row['CDREGIAO'],
                        'P_IDATIVO'           => $row['IDATIVO'],
                        'P_NRORG'             => $row['NRORG']
                    ];
                $this->supUtilities->crud($query, $params);    
        }
        catch (Exception $e) {
             throw $e;
        }
    }
    
    public function inactivateCategory($rows) 
    {
        try {
            $query = "UPDATE CATEGORIASUPPLY SET IDATIVO = :IDATIVO
                        WHERE CDCATEGORIA = :CDCATEGORIA
                      AND NRORG = :NRORG";

                foreach($rows as $row) {
                    $params = [
                    'IDATIVO'  => 'N',
                    'CDCATEGORIA'  => $row['CDCATEGORIA'],
                    'NRORG'           => $row['NRORG']
                    ];
                    $this->supUtilities->crud($query, $params); 
                }
        }
        catch (Exception $e) {
             throw $e;
        }
    }
       
    /********************
     *      DELETES     *
     * ******************/
    
    public function deleteCategory($rows) {
        try {
            $query = "DELETE FROM CATEGORIASUPPLY 
                       WHERE CDCATEGORIA = :CDCATEGORIA
                         AND NMCATEGORIA = :NMCATEGORIA
                         AND CDDESPPREV = :CDDESPPREV
                         AND NRORG = :NRORG";
                         
                foreach($rows as $row) {
                    $params = [
                        'CDCATEGORIA'       => $row['CDCATEGORIA'],
                        'NMCATEGORIA'       => $row['NMCATEGORIA'],
                        'CDDESPPREV'        => $row['CDDESPPREV'],
                        'NRORG'             => $row['NRORG']
                    ];
                    $this->supUtilities->crud($query, $params);
                }
        }
        catch (Exception $e) {
             throw $e;
        }
    }
    
    public function deleteSubCategory($row) {
        try {
            $query = "DELETE FROM SUBCATEGSUPPLY 
                       WHERE CDSUBCATEGORIA = :CDSUBCATEGORIA
                         AND NMSUBCATEGORIA = :NMSUBCATEGORIA
                         AND CDCATEGORIA = :CDCATEGORIA
                         AND NRORG = :NRORG";
            
                $params = [
                    'CDSUBCATEGORIA'    => $row["CDSUBCATEGORIA"],
                    'NMSUBCATEGORIA'    => $row['NMSUBCATEGORIA'],
                    'CDCATEGORIA'       => $row['CDCATEGORIA'],
                    'NRORG'             => $row['NRORG']
                ];
                $this->supUtilities->crud($query, $params);    
        }
        catch (Exception $e) {
             throw $e;
        }
    }
    
    public function deleteProdSubCategory($row) {
        try {
            //ATUALIZADO PARA INATIVAR
            $query = "UPDATE PRODSUPPLY 
                         SET IDATIVO = 'N'
                       WHERE CDSUBCATEGORIA = :CDSUBCATEGORIA
                         AND CDCATEGORIA    = :CDCATEGORIA
                         AND NRORG          = :NRORG";
            
                $params = [
                    'CDSUBCATEGORIA'    => $row["CDSUBCATEGORIA"],
                    'CDCATEGORIA'       => $row['CDCATEGORIA'],
                    'NRORG'             => $row['NRORG']
                ];
                $this->supUtilities->crud($query, $params);    
        }
        catch (Exception $e) {
             throw $e;
        }
    }
    
    public function deleteProduct($row) {
        try {
            $query = "DELETE FROM PRODSUPPLY
                         WHERE IDATIVO = :P_IDATIVO
                       AND CDCATEGORIA = :P_CDCATEGORIA
                         AND CDSUBCATEGORIA = :P_CDSUBCATEGORIA
                         AND CDFORNECED = :P_CDFORNECED
                         AND NRCOLEPRECO = :P_NRCOLEPRECO
                         AND CDPRODUTO = :P_CDPRODUTO
                         AND CDMARCA  = :P_CDMARCA
                         AND CDREGIAO  = :P_CDREGIAO
                         AND NRORG = :P_NRORG";
            
            $params = [
                'P_CDCATEGORIA'       => $row['CDCATEGORIA'],
                'P_CDSUBCATEGORIA'    => $row["CDSUBCATEGORIA"],
                'P_CDFORNECED'        => $row['CDFORNECED'],
                'P_NRCOLEPRECO'       => $row['NRCOLEPRECO'],
                'P_CDPRODUTO'         => $row['CDPRODUTO'],
                'P_CDMARCA'           => $row['CDMARCA'],
                'P_CDREGIAO'          => $row['CDREGIAO'],
                'P_IDATIVO'           => $row['IDATIVO'],
                'P_NRORG'             => $row['NRORG']
            ];
            
            $this->supUtilities->crud($query, $params);    
        }
        catch (Exception $e) {
             throw $e;
        }
    }
    
    public function deleteProductCart($row) {
        try {
            $query = "DELETE FROM PRODCART 
                       WHERE NRPRODCART = :NRPRODCART
                       AND CDMARCA = :CDMARCA
                         AND NRORG = :NRORG";
                        
            $params = [
                'CDMARCA'       => $row['CDMARCA'],
                'NRPRODCART'       => $row['NRPRODCART'],
                'NRORG'             => $row['NRORG']
            ];
            $this->supUtilities->crud($query, $params);
             
        }
        catch (Exception $e) {
             throw $e;
        }
    }
    
   /********************
    *      SELECTS     *
    * ******************/
    
    public function selectCart($row) {
        try {
            $query = "SELECT P.NRPRODCART ,C.CDOPERADOR, C.CDFILIAL , P.CDMARCA
            FROM prodcart p INNER JOIN cartsupply c on 
            (p.NRCARTSUPPLY = c.NRCARTSUPPLY AND p.CDPRODUTO = :CDPRODUTO AND p.CDMARCA = :CDMARCA AND C.NRORG = :NRORG)";
                $params = [
                    'CDMARCA'        => $row['CDMARCA'],
                    'CDPRODUTO'        => $row['CDPRODUTO'],
                    'NRORG'             => $row['NRORG']
                ];
                return $this->supUtilities->crud($query, $params);    
        }
        catch (Exception $e) {
             throw $e;
        }
    }
 
    public function selectCategory($row) {
        try {
            $query = "SELECT * FROM CATEGORIASUPPLY C,
                                    DESPPREV D
                        WHERE 
                        C.CDDESPPREV = D.CDDESPPREV
                        AND C.CDDESPPREV = :CDDESPPREV
                        AND C.NRORG = :NRORG
                        AND C.IDATIVO = 'S'";
                $params = [
                    'CDDESPPREV'        => $row['CDDESPPREV'],
                    'NRORG'             => $row['NRORG']
                ];
                return $this->supUtilities->crud($query, $params);    
        }
        catch (Exception $e) {
             throw $e;
        }
    }
    
    public function verifyCategory($row) {
        try {
            $query = "SELECT NRPRODCART FROM PRODCART
                        WHERE 
                        CDCATEGORIA = :CDCATEGORIA
                        AND NRORG = :NRORG
                        AND IDATIVO = 'S'";
                $params = [
                    'CDCATEGORIA'        => $row['CDCATEGORIA'],
                    'NRORG'             => $row['NRORG']
                ];
                return $this->supUtilities->crud($query, $params);    
        }
        catch (Exception $e) {
             throw $e;
        }
    }
    
    public function verifySubCategory($row) {
        try {
            $query = "SELECT NRPRODCART FROM PRODCART
                        WHERE 
                        CDSUBCATEGORIA = :CDSUBCATEGORIA
                        AND NRORG = :NRORG
                        AND IDATIVO = 'S'";
                $params = [
                    'CDSUBCATEGORIA'        => $row['CDSUBCATEGORIA'],
                    'NRORG'             => $row['NRORG']
                ];
                return $this->supUtilities->crud($query, $params);    
        }
        catch (Exception $e) {
             throw $e;
        }
    }
    
    public function selectCdProduct($row) {
        try {
            $sql = "SELECT DISTINCT
                        P.CDPRODUTO,
                        P.CDARVPROD,
                        P.IDATIVO,
                        P.NMPRODUTO,
                        P.CDNVPRODUTO,
                        P.IDPRODATIVPR,
                        I.CDREGIAO,
                        I.CDMARCA,
                        I.CDFILIAL,
                        I.VRPRECUNIITM
                    FROM
                        PRODUTO P,
                        ITEMCOLE I
                    WHERE
                        I.NRCOLEPRECO =:P_NRCOLEPRECO
                        AND P.CDPRODUTO = I.CDPRODUTO
                        AND P.CDARVPROD BETWEEN :P_CDARVPROD_INI AND :P_CDARVPROD_FIN
                        AND P.NRORG = I.NRORG";
                    
            $params = [
                'P_NRCOLEPRECO'     => $row['NRCOLEPRECO'],
                'P_CDARVPROD_INI'   => $row['CDARVPRODINI'],
                'P_CDARVPROD_FIN'   => $row['CDARVPRODFIN'] = self::strPadRigthProd($row['CDARVPRODFIN'])
            ];
            
            return $this->supUtilities->crud($sql, $params);    
        }
        catch (Exception $e) {
             throw $e;
        }
    }
    private function strPadRigthProd($value){
	    return str_pad($value, 20, 'Z', STR_PAD_RIGHT);
	}
	
	public function selectProductsToInactivate($row) {
        try {
            
            $sql = "SELECT DISTINCT
                        P.CDPRODUTO,
                        PS.CDCATEGORIA,
                        PS.CDSUBCATEGORIA,
                        PS.CDFORNECED,
                        I.NRCOLEPRECO,
                        P.CDARVPROD,
                        PS.IDATIVO,
                        PS.NRORG,
                        P.NMPRODUTO,
                        P.CDNVPRODUTO,
                        P.IDPRODATIVPR,
                        I.CDREGIAO,
                        I.CDMARCA,
                        I.CDFILIAL,
                        F.NMFANTFORN
                    FROM
                        PRODUTO P,
                        ITEMCOLE I,
                        PRODSUPPLY PS,
                        FORNECEDOR F
                    WHERE
                        (INSTR( :P_NRCOLEPRECO, I.NRCOLEPRECO ) > 0) 
                        AND P.CDPRODUTO = I.CDPRODUTO
                        AND P.CDARVPROD BETWEEN :P_CDARVPROD_INI AND :P_CDARVPROD_FIN
                        AND P.NRORG = I.NRORG
                        AND P.CDPRODUTO = PS.CDPRODUTO
                        AND I.CDMARCA = PS.CDMARCA
                        AND (INSTR( :P_CDMARCA, PS.CDMARCA ) > 0) 
                        AND F.CDFORNECED = PS.CDFORNECED";
                    
            $params = [
                'P_CDMARCA'     => $row['CDMARCA'],
                'P_NRCOLEPRECO'     => $row['NRCOLEPRECO'],
                'P_CDARVPROD_INI'   => $row['CDARVPRODINI'],
                'P_CDARVPROD_FIN'   => $row['CDARVPRODFIN'] = self::strPadRigthProd($row['CDARVPRODFIN'])
            ];
            
            return $this->supUtilities->crud($sql, $params);    
        }
        catch (Exception $e) {
             throw $e;
        }
    }

    public function checkProductAlreadyRegistered($row) {
        try {
            $sql = "SELECT
                        C.NMCATEGORIA,
                        S.NMSUBCATEGORIA,
                        R.NMREGIAO
                    FROM
                        PRODSUPPLY P,
                        CATEGORIASUPPLY C,
                        SUBCATEGSUPPLY S,
                        REGIAO R
                    WHERE
                        P.CDFORNECED = :P_CDFORNECED
                        AND P.CDPRODUTO = :P_CDPRODUTO
                        AND P.CDMARCA =:P_CDMARCA
                        AND P.CDREGIAO = :P_CDREGIAO
                        AND C.CDCATEGORIA = P.CDCATEGORIA
                        AND S.CDSUBCATEGORIA = P.CDSUBCATEGORIA
                        AND R.CDREGIAO = P.CDREGIAO
                        AND P.IDATIVO = 'S'";
                        
            $params = [
                'P_CDFORNECED' => $row['CDFORNECED'],
                'P_CDPRODUTO' => $row['CDPRODUTO'],
                'P_CDMARCA' => $row['CDMARCA'],
                'P_CDREGIAO' => $row['CDREGIAO']
            ];
            
            $result = $this->supUtilities->crud($sql, $params);
            
            return isset($result[0]) ? $result[0] : $result;
        }
        catch (Exception $e) {
             throw $e;
        }
    }
}