<?php
namespace Modules\Fornecimento\Modules\AutorizacaoFornecimento\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\GER\Controllers\TeknisaCrud;
use Modules\Fornecimento\Modules\AutorizacaoFornecimento\Services\ParametrosParaImportacaoDeAFService;

class ParametrosParaImportacaoDeAFController extends TeknisaCrud
{
    public function __construct($crudService, ParameterBag $parameterBag, ParametrosParaImportacaoDeAFService $service)
    {
        $this->crudService = $crudService;
        $this->service = $service;
    }
    
    public function confirmarImportacao (DTO\Request\Row $request, DTO\Response $response){
        
        $ParamImportAF = $this->GetParamImportAF('T');
        $lstErro = array();
        unset($lstErro);
        
        $boImpAuto = empty($ImportAF['CDOPERADOR']);
        
        if(strlen($ImportAF['AFCDPARAMINT']) > 0){
            $row = $request->getRow();
        
            $host = $ImportAF['DSHOST'];
            $intervalo = $ImportAF['VRINTERVALO'];
            $ftp_user = $ImportAF['DSLOGIN'];
            $ftp_pass = $ImportAF['DSSENHA'];
            
            $conn_id = ftp_connect($host) or die("Couldn't connect to $host");
        
            if (@ftp_login($conn_id, $ftp_user, $ftp_pass)) {
                ftp_pasv($conn_id, true) or die("Authorization failed");
                if (ftp_chdir($conn_id, "envio")) {
                    
                    $contents = ftp_nlist($conn_id, "/envio");
                    
                    for($i; $i < $contents; $i++){
                        ob_start();
                            $result = ftp_get($conn_id, "php://output", $contents[0], FTP_BINARY);
                            $stlColeta = ob_get_contents();
                        ob_end_clean();
                        
                        $OleResult = $this->ImportarAfSAP($stlColeta, $row['CDFORNECED']);
                        
                        if(empty($OleResult[0])){
                            if($OleResult[0] == 'ERRO'){
                                array_push($lstErro, "melancia");
                            }
                            else{
                                $new_file = substr($contents[$i], 0, strlen($contents[$i]) - 1).'k';
                                if (ftp_rename($conn_id, $contents[$i], $new_file)) {
                                    echo "successfully renamed $contents[$i] to $new_file\n";
                                } else {
                                    echo "There was a problem while renaming $contents[$i] to $new_file\n";
                                }
                            }
                        }
                        else{
                            $NImporta = array(); 
                            
                            $NImporta = array_push($NImporta, $OleResult[1]);
                            
                            if(empty($NImporta)){
                                if($boImpAuto){
                                    //MSG DE ERRO Linha 88
                                }
                            }
                            else{
                                $inContaPedido      = 0;
                                $inContaPedidoOk    = 0;
                                
                                foreach ($NImporta as $NImporta) {
                                    $inConta = $inConta + 1;
                                    $inContaPedido  = $inContaPedido + 1;
                                    $stMensRetorno  = '';
                                    $stNMArquivo    = '';
                                    //$stErro = Linha 99
                                    $stUsr_NrImportAF = $NImporta['USR_NRIMPORTAF'];
                                    $inUsr_NrImportAF = strlen($stUsr_NrImportAF);
                                    //$stUsr_NrImportAF__ = Linha 102
                                    $stUsr_NrImportAF = $stUsr_NrImportAF + str_replace($stUsr_NrImportAF__, '0', ' ');
                                    
                                    $stChaveAF = $NImporta['CDFILDEST'].$NImporta['CDFILLANC'].$NImporta['NRAUTOFORN'];
                                    $stNmProduto = substr($NImporta['NMPRODUTO'], 0, 20);
                                    $stNmFilial = substr($NImporta['NMFILIAL'], 0, 20);
                                    $stFornecedor = $NImporta['NRINSJURFORN'];
                                    if($stErro[1] == 'X'){
                                        $stChaveAF = $NImporta['CDFILDEST'].$NImporta['CDFILLANC'].$NImporta['NRAUTOFORN'];
                                        $boConfirma = true;
                                        
                                        //Codigo estranho linha 116
                                        $inContaPedidoOk = $inContaPedidoOk + 1;
                                    }
                                    else{
                                        $stChaveAF = '                  ';
                                        if(strpos($stErro[10],'1') > 0){
                                            //$stMensErro = Linha 122
                                            array_push($lstErro, $stMensErro);
                                            $stMensRetorno = $stMensRetorno.$stMensErro;
                                            $stMensErro = '';
                                        }if(strpos($stErro[9],'1') > 0){
                                            //$stMensErro = Linha 128 a 129
                                            array_push($lstErro, $stMensErro);
                                            $stMensRetorno = $stMensRetorno.$stMensErro;
                                            $stMensErro = '';
                                        }if(strpos($stErro[8],'1') > 0){
                                            //$stMensErro = Linha 135 a 137
                                            array_push($lstErro, $stMensErro);
                                            $stMensRetorno = $stMensRetorno.$stMensErro;
                                            $stMensErro = '';
                                        }if(strpos($stErro[7],'1') > 0){
                                            //$stMensErro = Linha 143 a 144
                                            array_push($lstErro, $stMensErro);
                                            $stMensRetorno = $stMensRetorno.$stMensErro;
                                            $stMensErro = '';
                                        }if(strpos($stErro[6],'1') > 0){
                                            //$stMensErro = Linha 150 a 151
                                            array_push($lstErro, $stMensErro);
                                            $stMensRetorno = $stMensRetorno.$stMensErro;
                                            $stMensErro = '';
                                        }if(strpos($stErro[5],'1') > 0){
                                            //$stMensErro = Linha 157 a 158
                                            array_push($lstErro, $stMensErro);
                                            $stMensRetorno = $stMensRetorno.$stMensErro;
                                            $stMensErro = '';
                                        }if(strpos($stErro[4],'1') > 0){
                                            //$stMensErro = Linha 164 a 165
                                            array_push($lstErro, $stMensErro);
                                            $stMensRetorno = $stMensRetorno.$stMensErro;
                                            $stMensErro = '';
                                        }if(strpos($stErro[3],'1') > 0){
                                            //$stMensErro = Linha 171 a 173
                                            array_push($lstErro, $stMensErro);
                                            $stMensRetorno = $stMensRetorno.$stMensErro;
                                            $stMensErro = '';
                                        }if(strpos($stErro[2],'1') > 0){
                                            //$stMensErro = Linha 179 a 181
                                            array_push($lstErro, $stMensErro);
                                            $stMensRetorno = $stMensRetorno.$stMensErro;
                                            $stMensErro = '';
                                        }if(strpos($stErro[1],'1') > 0){
                                            //$stMensErro = Linha 187 a 188
                                            array_push($lstErro, $stMensErro);
                                            $stMensRetorno = $stMensRetorno.$stMensErro;
                                            $stMensErro = '';
                                        }if(strpos($stErro[11],'1') > 0){
                                            //$stMensErro = Linha 194
                                            array_push($lstErro, $stMensErro);
                                            $stMensRetorno = $stMensRetorno.$stMensErro;
                                            $stMensErro = '';
                                        }
                                        if(!empty($stMensRetorno)){
                                            $stMensRetorno = substr($stMensRetorno, 0, 4000);
                                            //Linha 201
                                        }
                                    }
                                }
                                $stNMArquivo = $contents[$i];
                                
                                if($inContaPedidoOk == $inContaPedido){
                                    //$stMensagem = Linha 208
                                }
                                else{
                                    //$stMensagem = Linha 212
                                }
                                $stNomeArq = $ImportAF['DSDIRENVIO'];
                                $stNomeArq1 = 'SAPORE_TXT_'.date('d-m-Y H:i:s').$inConta.'txt'; 
                                $stNomeArq = $stNomeArq.$stNomeArq1;
                                
                                if (ftp_chdir($conn_id, "../recebimento/")) {
                                    if (ftp_get($conn_id, $stNomeArq, $contents[$i], FTP_BINARY)) {
                                        echo "Successfully written to $local_file\n";
                                    } else {
                                        echo "There was a problem\n";
                                    }                                
                                }
                                else {
                                    echo "Não foi possível mudar o diretório\n";
                                }
                            }
                        }
                        if (ftp_chdir($conn_id, "../envio/")) {
                            if (ftp_delete($conn_id, $contents[$i])) {
                               echo "O arquivo $contents[$i] foi excluído\n";
                            } else {
                               echo "não foi possível excluir $contents[$i]\n";
                            }                                   
                        }
                        else {
                            echo "Não foi possível mudar o diretório\n";
                        }
                    }
                } else {
                    echo "Não foi possível mudar o diretório\n";
                }
            } else {
                echo "Couldn't connect as $ftp_user\n";
            }
            
            // if(count($lstErro) == 0){
            if (((is_array($lstErro) && !is_null($lstErro)) ? count($lstErro) : 0) == 0) {
                if($boConfirma){
                    if($boImpAuto){
                        //MSG ERRO Linha 239
                    }
                }
                else{
                    if($boImpAuto){
                        //MSG ERRO Linha 243
                    }
                }
            }
            else{
                if($boImpAuto){
                    //MSG ERRO Linha 248
                }
            }
            ftp_close($conn_id);
            if($boImpAuto == false && $inConta > 0){
                if(!empty($ImportAF['CDOPERADOR'])){
                    //SELECT NO BANCO Linha 258 a 263
                    
                    $stData = date('d-m-Y');
                    $stHora = date('H:i:s');
                    //$stMsgGestor = Linha 266 a 267
                    $stMsgGestor = $stMsgGestor + $stMensagem;
                    $stErro_Email = $this->EnviaEmail();
                    if(!empty($stErro_Email)){
                        //MSG ERRO Linha 271
                    }
                }    
            }
        }
        else {
            //MSG ERRO Linha 276
        }
    }
    
    public function EnviaEmail(){
        
    }
    
    public function SepDecimal($stValue, $nrCasa){
        $I = strlen($stValue);
        $result = substr($stValue, 0, ($I - $nrCasa)).'.'.substr($stValue, (($I - $nrCasa) + 1), $I);
    }

    public function ImportarAfSAP($af, $FORNECED){
        $lines = explode("\n", $af);
        
        $NImporta = array(
            "NMFILIAL"      => "",
            "NRAUTOFORN"    => "",
            "NMFANTFORN"    => "",
            "CDFILDEST"     => "",
            "CDFILLANC"     => "",
            "CDPRODUTO"     => "",
            "CDARVPROD"     => "",
            "NMPRODUTO"     => "",
            "USR_NRIMPORTAF"=> "",
            "NRINSJURFORN"  => "",
            "CDFILCENTCMP"  => "",
            "CDREGIAO"      => "",
            "ERRO"          => "",
            "TAG"           => "",
        );
        
        $ExceptionArray = array();
        
        
        $Result = array();
        $Result[1] = $NImporta;
        
        $boImporta = true;
        $dtProgentAf = 0;
        $stErro = array('0','0','0','0','0','0','0','0','0','0','0');
        
        try{
            // if(count($lines) == 0){
            if (((is_array($lines) && !is_null($lines)) ? count($lines) : 0) == 0) {
                $boImporta = false;
            }
            
            $NImporta["TAG"] = 0;
            
            for($i = 0; $i < count($lines); $i++){
                $stIdRegistro = substr($lines[$i], 1, 1);
                
                if($stIdRegistro == '1'){
                    for($j = 0; $j < 11; $j++){
                        $stErro[$j] = '0';    
                    }
                    $stPedido = substr($lines[$i], 2, 12);
                    
                    $stUsr_ImportAf = substr($stPedido, 0, 10);
                    $stUsr_ImportAf = str_pad($stUsr_ImportAf, strlen($stUsr_ImportAf) + 10, '0', STR_PAD_LEFT);
            
                    $stCdForneced = 'J'.substr($lines[$i], 73, 21);
                    
                    //FAZ SELECT NO BANCO linha 455 a 460
                    $adqAutoForne_USR = $this->service->adqAutoForne_USR($stUsr_ImportAf, $stCdForneced);
                }
                if(strlen($adqAutoForne_USR['USR_NRIMPORTAF']) == 0){
                    if($stIdRegistro == '1'){
                        $stDia = substr($lines[$i], 55, 2);      
                        $stMes = substr($lines[$i], 57, 2);      
                        $stAno = substr($lines[$i], 59, 4);
                        
                        $dateFormat = strtotime($stDia."/".$stMes."/".$stAno);
                        $dtProgentAf = date('d-m-Y',$dateFormat);
                        
                        $boImporta = true;
                        $stFiliDest = substr($lines[$i], 30, 4);
                        
                        //FAZ SELECT NO BANCO linha 471 a 475
                        $adqFilDest = $this->service->adqFilDest($stFiliDest);
                        
                        
                        if(empty($adqFilDest)){
                            //MSG ERRO linha 477
                            $stErro[9] = 1;
                            $boImporta = false;
                        }
                        else{
                            if($stCdForneced != $FORNECED && $FORNECED != 'J09216620000137'){
                                //MSG ERRO linha 483
                                $stErro[10] = '1';
                                $boImporta = false;
                            }
                            else{
                                $adqFornecedor = $this->service->adqFilDest($stCdForneced);
                                
                                if(empty($adqFornecedor)){
                                    //MSG ERRO linha 494 
                                    $stErro[0] = '1';
                                    $boImporta = false;
                                }
                                else{
                                    $dtmProxCodigo = null;
                                    
                                    //Monte de código que não entendi 502 a 508
                                    
                                    $stOperador = '000000000987';
                                    
                                    //FAZ SELECT NO BANCO linha 510 a 516
                                    $adqAutoForne = $this->service->adqFilDest($stFiliDest, $P_CDFILLANC, $stNrAutoForn);
                                    
                                    
                                    if(empty($adqAutoForne)){
                                        $stCdFormPgto = $adqFornecedor['CDFORMPGTO'];
                                        $stIdTpForPgtFo = $adqFornecedor['IDTPFORPGTFO'];
                                        $stEmpresa = '01';
                                        
                                        //FAZ INSERT NO BANCO linha 521 a 534
                                        $this->service->acmInsAutoForne($stFiliDest, $P_CDFILLANC, $stNrAutoForn, $stOperador, $stCdForneced, $stCdFormPgto, $stIdTpForPgtFo, $stEmpresa, $adqFornecedor['NRPARCPGTOFO'], $adqFornecedor['NRDIAPGFIXFO'], $adqFornecedor['IDUTDIAPGTFO']);
                                        
                                        if($stIdTpForPgtFo == 'V'){
                                            //FAZ SELECT NO BANCO linha 536 a 542
                                            $acmInsPrazoPgtAF = $this->service->acmInsPrazoPgtAF($stFiliDest, $P_CDFILLANC, $stNrAutoForn, $stCdForneced);
                                        }
                                    }
                                    else{
                                        //MSG ERRO linha 546
                                        $stErro[8] = '1';
                                        $boImporta = false;
                                        //variavel estranha linha 549
                                    }
                                }
                            }
                        }
                    }
                    elseif ($stIdRegistro = '2' && !empty($adqFornecedor)){
                        for($j = 0; $j < 11; $j++){
                            $stErro[$j] = '0';    
                        }
                        $stProduto = substr($lines[$i], 25, 10);
                        
                        //FAZ SELECT NO BANCO linha 558 a 562
                        $adqProduto = $this->service->adqProduto($stProduto);
                        
                        if(strlen($adqProduto['CDPRODUTO']) == 0){
                           //MSG ERRO linha 564
                           $stErro[6] = '1';
                           $boImporta = false;
                        }
                        else{
                            
                            //FAZ SELECT NO BANCO linha 569 a 574
                            $adqProdForn = $this->service->adqProdForn($stProduto, $stCdForneced);
                            
                            if(strlen($adqProdForn['CDPRODCOMPL']) == 0){
                               //MSG ERRO linha 576
                               $stErro[5] = '1';
                               $boImporta = false;
                            }
                            else{
                                $stMarca = '00680';
                                $stQtProgentAF = $this->SepDecimal((substr($lines[$i], 43, 11)),4);
                                $doQtProgentAF = (float) $stQtProgentAF;
                                $stVrPreUniAF = $this->SepDecimal((substr($lines[$i], 70, 11)),4);
                                $doVrPreUniAF = (float) $stVrPreUniAF;
                                if($doQtProgentAF <= 0){
                                    $stErro[4] = '1';
                                    $boImporta = false;
                                }
                                if($doVrPreUniAF <= 0){
                                    $stErro[3] = '1';
                                    $boImporta = false;
                                }
                                else{
                                    
                                    //FAZ SELECT NO BANCO linha 595 a 604
                                    $adqMelhorPreco = $this->service->adqMelhorPreco($adqFilDest['CDFILCENTCMP'], $stCdForneced, $adqFilDest['CDFILIAL'], $dtProgentAf, $stProduto);
                                    
                                    if(strlen($adqMelhorPreco['CDFILIAL']) == 0){
                                        $stErro[2] = '1';
                                        $boImporta = false;
                                    }
                                    else{
                                        if(strlen($adqMelhorPreco['CDFILIAL']) > 0){
                                            //codigo estranho linha 611
                                        }
                                        //variavel estranha linha 613
                                        if($boImporta){
                                            //variavel estranha linha 615
                                        }
                                        
                                        //while(/*linha 617*///){
                                            $doVrPrecUniItm = (float)$adqMelhorPreco['VRPRECUNIITM'];
                                            if(round($doVrPreUniAF, 4) != round($doVrPrecUniItm, 4)){
                                                $stErro[7] = '1';
                                                $boImporta = false;
                                            }
                                            else{
                                                if(/*linha 624*/){
                                                    $boImporta = true;
                                                }
                                                $stErro[7] = '0';
                                                break;
                                            }
                                            // codigo estranho linha 630
                                        //}
                                    }
                                }
                                if($boImporta){
                                   //FAZ SELECT NO BANCO linha 635 a 645
                                   $adqMelhorPreco = $this->service->adqMelhorPreco($stFiliDest, , , $stMarca, $stProduto, $doQtProgentAF, $doVrPreUniAF, $dtProgentAF);
                                   
                                }
                            }
                        }
                        $tsErro = implode('', $stErro);
                        if(!$boImporta && $tsErro != '00000000000'){
                            if(array_key_exists("CDFILDEST", $NImporta) && array_key_exists("CDFILLANC", $NImporta) && array_key_exists("NRAUTOFORN", $NImporta) && array_key_exists("CDPRODUTO", $NImporta)){
                                if($stErro[10] == '1'){
                                    $stCdForneced = $FORNECED;
                                }
                                $NImporta["NMFILIAL"]       = $adqFilDest['NMFILIAL'];
                                $NImporta["NRAUTOFORN"]     = $stNrAutoForn;
                                $NImporta["NMFANTFORN"]     = $adqFornecedor['NMFANTFORN'];
                                $NImporta["CDFILDEST"]      = $stFiliDest;
                                $NImporta["CDFILLANC"]      = $P_CDFILLANC
                                $NImporta["CDPRODUTO"]      = $adqProduto['CDPRODUTO'];
                                $NImporta["CDARVPROD"]      = $adqProduto['CDARVPROD'];
                                $NImporta["NMPRODUTO"]      = $adqProduto['NMPRODUTO'];
                                $NImporta["USR_NRIMPORTAF"] = $stPedido;
                                $NImporta["NRINSJURFORN"]   = substr($stCdForneced, 1, 20);
                                $NImporta["CDFILCENTCMP"]   = $adqFilDest['CDFILCENTCMP'];
                                $NImporta["CDREGIAO"]       = $adqFilDest['CDREGIAO'];
                                $NImporta["ERRO"]           = $tsErro;
                            }
                        }
                    }
                    elseif ($stIdRegistro = '3') {
                        $tsErro = implode('', $stErro);
                        if($boImporta && $tsErro = '00000000000'){
                            
                           //FAZ SELECT NO BANCO linha 675 a 682
                            $acmInsMensAutF = $this->service->acmInsMensAutF($stFiliDest, $P_CDFILLANC, $stNrAutoForn, '01', 'Pedido: '.$stUsr_ImportAF.' Importação de AF Sapore/BR Supply.');
                           
                           $stMensAutf = substr($lines[$i], 122, 400);
                        }
                        if(!empty($stMensAutf)){
                            
                            //FAZ SELECT NO BANCO linha 685 a 692
                            $acmInsMensAutF = $this->service->acmInsMensAutF($stFiliDest, $P_CDFILLANC, $stNrAutoForn, '02', $stMensAutf);
                        }
                        
                        //FAZ SELECT NO BANCO linha 694 a 699
                        
                        
                        //FAZ SELECT NO BANCO linha 700 a 706
                        $acmUpdAutoForne = $this->service->acmUpdAutoForne($stUsr_ImportAF, $stFiliDest, $P_CDFILLANC, $stNrAutoForn);
                        
                        //codigo estranho linha 707 e 708
                        $NImporta["TAG"] = 99
                        
                        if(array_key_exists("USR_NRIMPORTAF", $NImporta) && array_key_exists("ERRO", $NImporta)){
                            //muitos codigos estranhos linha 710 a 724
                            $NImporta["NMFILIAL"]       = $adqFilDest['NMFILIAL'];
                            $NImporta["NRAUTOFORN"]     = $stNrAutoForn;
                            $NImporta["NMFANTFORN"]     = $adqFornecedor['NMFANTFORN'];
                            $NImporta["CDFILDEST"]      = $stFiliDest;
                            $NImporta["CDFILLANC"]      = $P_CDFILLANC
                            $NImporta["CDPRODUTO"]      = $adqProduto['CDPRODUTO'];
                            $NImporta["CDARVPROD"]      = $adqProduto['CDARVPROD'];
                            $NImporta["NMPRODUTO"]      = $adqProduto['NMPRODUTO'];
                            $NImporta["USR_NRIMPORTAF"] = $stPedido;
                            $NImporta["NRINSJURFORN"]   = substr($stCdForneced, 1, 20);
                            $NImporta["CDFILCENTCMP"]   = $adqFilDest['CDFILCENTCMP'];
                            $NImporta["CDREGIAO"]       = $adqFilDest['CDREGIAO'];
                            $NImporta["ERRO"]           = $tsErro;
                        }
                        else{
                            
                            //FAZ SELECT NO BANCO linha 728 a 733
                            $acmDelAutoforn = $this->service->acmDelAutoforn($stFiliDest, $P_CDFILLANC, $stNrAutoForn);
                            
                            //codigo estranho linha 734
                        }
                    }
                    if($stIdRegistro == '3'){
                        $tsErro = implode('', $stErro);
                        if(!$boImporta && $tsErro != '00000000000'){
                            if(array_key_exists("CDFILDEST", $NImporta) && array_key_exists("CDFILLANC", $NImporta) && array_key_exists("NRAUTOFORN", $NImporta) && array_key_exists("CDPRODUTO", $NImporta)){
                                $NImporta["NMFILIAL"]       = $adqFilDest['NMFILIAL'];
                                $NImporta["NRAUTOFORN"]     = $stNrAutoForn;
                                $NImporta["NMFANTFORN"]     = $adqFornecedor['NMFANTFORN'];
                                $NImporta["CDFILDEST"]      = $stFiliDest;
                                $NImporta["CDFILLANC"]      = $P_CDFILLANC
                                $NImporta["CDPRODUTO"]      = $adqProduto['CDPRODUTO'];
                                $NImporta["CDARVPROD"]      = $adqProduto['CDARVPROD'];
                                $NImporta["NMPRODUTO"]      = $adqProduto['NMPRODUTO'];
                                $NImporta["USR_NRIMPORTAF"] = $stPedido;
                                $NImporta["NRINSJURFORN"]   = substr($stCdForneced, 1, 20);
                                $NImporta["CDFILCENTCMP"]   = $adqFilDest['CDFILCENTCMP'];
                                $NImporta["CDREGIAO"]       = $adqFilDest['CDREGIAO'];
                                $NImporta["ERRO"]           = $tsErro; 
                            }
                            
                            //FAZ SELECT NO BANCO linha 760 a 765
                            $acmDelAutoforn = $this->service->acmDelAutoforn($stFiliDest, $P_CDFILLANC, $stNrAutoForn);
                            
                            //codigo estranho linha 766
                        }
                    }
                    else{
                        if(array_key_exists("USR_NRIMPORTAF", $NImporta)){
                            $stErro[1] = '1';
                            $NImporta["NMFILIAL"]       = '';
                            $NImporta["NRAUTOFORN"]     = $adqAutoForne_USR['NRAUTOFORN'];
                            $NImporta["NMFANTFORN"]     = '';
                            $NImporta["CDFILDEST"]      = $adqAutoForne_USR['CDFILDEST'];
                            $NImporta["CDFILLANC"]      = $adqAutoForne_USR['CDFILLANC'];
                            $NImporta["CDPRODUTO"]      = '';
                            $NImporta["CDARVPROD"]      = '';
                            $NImporta["NMPRODUTO"]      = '';
                            $NImporta["USR_NRIMPORTAF"] = $adqAutoForne_USR['USR_NRIMPORTAFI'];
                            $NImporta["NRINSJURFORN"]   = substr($stCdForneced, 1, 20);
                            $NImporta["CDFILCENTCMP"]   = '';
                            $NImporta["CDREGIAO"]       = '';
                            $NImporta["ERRO"]           = $stErro;
                        }
                    }
                }
            }
            if($NImporta["TAG"] == 0){
                $NImporta["NMFILIAL"]       = '';
                $NImporta["NRAUTOFORN"]     = '';
                $NImporta["NMFANTFORN"]     = '';
                $NImporta["CDFILDEST"]      = '';
                $NImporta["CDFILLANC"]      = '';
                $NImporta["CDPRODUTO"]      = '';
                $NImporta["CDARVPROD"]      = '';
                $NImporta["NMPRODUTO"]      = '';
                $NImporta["USR_NRIMPORTAF"] = '';
                $NImporta["NRINSJURFORN"]   = '';
                $NImporta["CDFILCENTCMP"]   = '';
                $NImporta["CDREGIAO"]       = '';
                $NImporta["ERRO"]           = '';
            }
            if(!empty($NImporta)){
                $Result[1] = $NImporta;
            }
        }
        catch(Exception $e){
            $NImporta["NMFILIAL"]       = '';
            $NImporta["NRAUTOFORN"]     = '';
            $NImporta["NMFANTFORN"]     = '';
            $NImporta["CDFILDEST"]      = '';
            $NImporta["CDFILLANC"]      = '';
            $NImporta["CDPRODUTO"]      = '';
            $NImporta["CDARVPROD"]      = '';
            $NImporta["NMPRODUTO"]      = '';
            $NImporta["USR_NRIMPORTAF"] = '';
            $NImporta["NRINSJURFORN"]   = '';
            $NImporta["CDFILCENTCMP"]   = '';
            $NImporta["CDREGIAO"]       = '';
            $NImporta["ERRO"]           = '';
            
            $ExceptionArray[0] = $e;
            $ExceptionArray[1] = $NImport;
            
            $Result[0] = $ExceptionArray;
        }
        
        if(!empty($NImporta)){
            
            try{
                foreach($NImporta){
                    
                    if($NImporta['ERRO'] != 'X'){
                        
                        $tsErro = implode('', $stErro);
                        
                        //FAZ SELECT NO BANCO linha 812 a 818
                        $acmLogImpItemautf = $this->service->acmLogImpItemautf($NImporta['USR_NRIMPORTAF'], $NImporta['CDFILDEST'], $NImporta['CDPRODUTO'], $dtProgentAF, $tsErro);
                    }
                }
            }
            catch(Exception $e){
                $NImporta["NMFILIAL"]       = '';
                $NImporta["NRAUTOFORN"]     = '';
                $NImporta["NMFANTFORN"]     = '';
                $NImporta["CDFILDEST"]      = '';
                $NImporta["CDFILLANC"]      = '';
                $NImporta["CDPRODUTO"]      = '';
                $NImporta["CDARVPROD"]      = '';
                $NImporta["NMPRODUTO"]      = '';
                $NImporta["USR_NRIMPORTAF"] = '';
                $NImporta["NRINSJURFORN"]   = '';
                $NImporta["CDFILCENTCMP"]   = '';
                $NImporta["CDREGIAO"]       = '';
                $NImporta["ERRO"]           = '';
                
                $ExceptionArray[0] = $e;
                $ExceptionArray[1] = $NImport;
                
                $Result[0] = $ExceptionArray;  
            }
        }
        return $Result;
    }
    
    public function GetParamImportAF($CDFORNECED){
        try{
            if(strlen($CDFORNECED) > 1){
                return $this->service->adqFornParamImpAf($CDFORNECED)[0];
            }
            else if(strlen($CDFORNECED) == 'T'){
                return $this->service->adqFornParamImpAf('T')[0];
            }
        }
        catch (Exception $e){
            throw $e;
        }
    }
    
    public function SetParamImportAF(const $P_DSDIRENVIO, $P_HOST, $P_LOGIN, $P_SENHA, $P_CDOPERADOR, $P_VRINTERVALO, $P_CDFORNECED){
        
        //FAZ DELETE NO BANCO LINHA 862 A 865
        $this->service->acmDelParamImportAF($P_CDFORNECED, $P_DSDIRENVIO, $P_HOST, $P_LOGIN, $P_SENHA, $P_CDOPERADOR, $P_VRINTERVALO);
        
        //FAZ INSERT NO BANCO LINHA 866 A 875
        $this->service->acmInsParamImportAF($P_CDFORNECED);
    }
}